package team.tilde.mabri.doodlepadme;

import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.Display;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;

class MyCanvas extends Canvas {
	int lastKeyCode;
	boolean keyWasPressed;
	boolean isPenUp;
	int[] curPointsX;
	int[] curPointsY;
	int curIndex;
	MyCanvas() {
		super();
		keyWasPressed = false;
		isPenUp = false;
		curPointsX = new int[10000];
		curPointsY = new int[10000];
		curIndex = 0;
		setFullScreenMode(true);
	}
	public void togglePenUp() {
		isPenUp = !isPenUp;
	}
	protected void keyRepeated(int keyCode) {
		keyPressed(keyCode);
	}
	protected void keyPressed(int keyCode) {
		lastKeyCode = keyCode;
		keyWasPressed = true;
		repaint();
	}
	protected void paint(Graphics g) {
		g.fillRect(0, 0, getWidth(), getHeight());
		g.setColor(0x00ffffff);
		if (keyWasPressed) {
			switch (getGameAction(lastKeyCode)) {
				case UP:	updatePosBy(0, -1);
							break;
				case DOWN:  updatePosBy(0, 1);
							break;
				case LEFT:  updatePosBy(-1, 0);
							break;
				case RIGHT: updatePosBy(1, 0);
				default:	break;
			}
		}
		for (int i = 0; i < curIndex - 1; i++) {
			int lastPointX = curPointsX[i];
			int lastPointY = curPointsY[i];
			int curPointX  = curPointsX[i + 1];
			int curPointY  = curPointsY[i + 1];
			if (curPointX >= 0) { // negative means reached with pen up
				if (lastPointX < 0) {
					lastPointX = -lastPointX-1;
				}
				g.drawLine(lastPointX, lastPointY, curPointX, curPointY);
			}
		}
		keyWasPressed = false;
	}
	private void updatePosBy(int diffX, int diffY) {
		int curPointX = curPointsX[curIndex];
		int curPointY = curPointsY[curIndex];
		if (curPointX < 0) {
			curPointX = -curPointX - 1;
		}
		curPointX += diffX;
		curPointY += diffY;
		if ((curIndex < curPointsX.length - 1) && (curPointX >= 0) &&
			(curPointY >= 0)) {
			if (isPenUp) {
				curPointX = -curPointX-1;
			}
			curPointsX[curIndex + 1] = curPointX;
			curPointsY[curIndex + 1] = curPointY;
			curIndex++;
		}
	}
}

public class DoodlePadME extends MIDlet implements CommandListener {
	MyCanvas theCanvas;
	public DoodlePadME() {
		theCanvas = new MyCanvas();
	}
	protected void startApp() {
		theCanvas.addCommand(new Command("Quit", Command.EXIT, 1));
		theCanvas.addCommand(new Command("Pen lift on/off", Command.ITEM
										, 1));
		theCanvas.setCommandListener(this);
		Display.getDisplay(this).setCurrent(theCanvas);
	}
	protected void pauseApp() {
		//;
	}
	protected void destroyApp(boolean unconditional) {
		theCanvas = null;
	}
	public void commandAction(Command c, Displayable d) {
		if (c.getCommandType() == Command.EXIT) {
			destroyApp(true);
			notifyDestroyed();
		} else {
			theCanvas.togglePenUp();
		}
	}
}

