package team.tilde.mabri.tonetest;

import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Alert;

import javax.microedition.media.Manager;
import javax.microedition.media.MediaException;
import javax.microedition.lcdui.AlertType;

interface KeyEventListener {
	void keyPressed(int key); // using byte here gives the error message
	// "incompatible types: possible lossy conversion from int to byte"
}

interface KeyEventProducer {
	void addKeyListener(KeyEventListener listener);
}

public class MyKeyTones extends MIDlet implements KeyEventListener {
//	const SEMITONE_CONST = 1/Math.ln(Math.pow(2, 1.0/12));
	MyKeysProducer theKeys;
	public MyKeyTones() {
		theKeys = new MyKeysProducer();
	}
	void emitToneWithKey(int key) {
		//(MIDI) note = Math.round(Math.ln(freq/8.176)*SEMITONE_CONST);
		int note = 59 + key; // A: 10th note of the 12 (C 1st), right?
		try {
			Manager.playTone(note, 250 /* ms (quarter at 60 bpm) */,40);
		} catch (MediaException me) {
			Display.getDisplay(this)
					.setCurrent(new Alert(null, me.getMessage(), null,
									AlertType.ERROR), theKeys);
		}
	}
	public void keyPressed(int key) {
		if (key == 0) {
			destroyApp(false);
			notifyDestroyed();
		} else {
			emitToneWithKey(key);
		}
	}

	protected void startApp() {
		theKeys.addKeyListener(this);
		Display.getDisplay(this).setCurrent(theKeys);
	}
	protected void pauseApp() {
		//;
	}
	protected void destroyApp(boolean unconditional) {
		theKeys = null;
	}
}
