package team.tilde.mabri.scrawlpadme;

import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.Display;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Graphics;

class MyCanvas extends Canvas {
	int lastKeyCode;
	boolean keyWasPressed;
	int[] curPointsX;
	int[] curPointsY;
	int curIndex;
	MyCanvas() {
		super();
		keyWasPressed = false;
		curPointsX = new int[10000];
		curPointsY = new int[10000];
		curIndex = 0;
		setFullScreenMode(true);
	}
	protected void keyPressed(int keyCode) {
		lastKeyCode = keyCode;
		keyWasPressed = true;
		repaint();
	}
	protected void paint(Graphics g) {
		g.fillRect(0, 0, getWidth(), getHeight());
		g.setColor(0x00ffffff);
		if (!keyWasPressed) return;
		switch (getGameAction(lastKeyCode)) {
			case UP:	updatePosBy(0, -1);
						break;
			case DOWN:  updatePosBy(0, 1);
					    break;
			case LEFT:  updatePosBy(-1, 0);
					    break;
			case RIGHT: updatePosBy(1, 0);
						break;
		}

		for (int i = 0; i < curIndex - 1; i++) {
			int lastPointX = curPointsX[i];
			int lastPointY = curPointsY[i];
			int curPointX  = curPointsX[i + 1];
			int curPointY  = curPointsY[i + 1];			
			g.drawLine(lastPointX, lastPointY, curPointX, curPointY);
		}
		keyWasPressed = false;
	}
	private void updatePosBy(int diffX, int diffY) {
		int curPointX = curPointsX[curIndex];
		int curPointY = curPointsY[curIndex];
		curPointX += diffX;
		curPointY += diffY;
		if ((curIndex < curPointsX.length - 1) && (curPointX >= 0) &&
			(curPointY >= 0)) {
			curPointsX[curIndex + 1] = curPointX;
			curPointsY[curIndex + 1] = curPointY;
			curIndex++;
		}
	}
}

public class ScrawlPadME extends MIDlet {
	MyCanvas theCanvas;
	public ScrawlPadME() {
		theCanvas = new MyCanvas();
	}
	protected void startApp() {
		Display.getDisplay(this).setCurrent(theCanvas);
	}
	protected void pauseApp() {
		//;
	}
	protected void destroyApp(boolean unconditional) {
		theCanvas = null;
	}
}

